<?php
//Original from peter dot hulstaert at gmail dot com
//Available at http://php.net/manual/en/ref.image.php#60410
//Modified for tracker usage stats by Oryde

// Define variables
$imgWidth=640;  //width
$imgHeight=180; //height
$grid=10;       //grid cell height
$graphspacing=0.01;
//Scales number of vertical grid lines for the number of data to print
$gridW=$imgWidth/24;
$usageStatsF = "trackerUsage.txt"; //serialized stats file
$usageGraph = "trackerUsage.png";  //saved graph image

header("Content-type: image/png");

if (file_exists($usageGraph)&&date("H", filemtime($usageGraph))==date("H"))
        die(file_get_contents($usageGraph));     

if (file_exists($usageStatsF)){
    $statsArr = unserialize(file_get_contents($usageStatsF));
    $Values1 = $statsArr["today"];
    $Values2 = $statsArr["lastday"];
}
else{
    $Values1 = array(0);
    $Values2 = array(0);
}



//Get min and max values to scale image
for ($i=0; $i<count($Values1); $i++){
  if ($Values1[$i]>$max){$max=$Values1[$i];}
}
for ($i=0; $i<count($Values2); $i++){
  if ($Values2[$i]>$max){$max=$Values2[$i];}
}
//Min values are less the maximum...
$min = $max;

for ($i=0; $i<count($Values1); $i++){
  if ($Values1[$i]<$min){$min=$Values1[$i];}
}
for ($i=0; $i<count($Values2); $i++){
  if ($Values2[$i]<$min){$min=$Values2[$i];}
}
for ($i=0; $i<count($Values1); $i++){
  $graphValues1[$i] =
 ($Values1[$i] - $min*(1-2*$graphspacing)) *
 (($imgHeight*(1-$graphspacing))/($max-$min)*(1-2*$graphspacing));
}
for ($i=0; $i<count($Values2); $i++){
  $graphValues2[$i] =
 ($Values2[$i] - $min*(1-2*$graphspacing)) *
 (($imgHeight*(1-$graphspacing))/($max-$min)*(1-2*$graphspacing));
}
// Create image and define colors
$image=imagecreate($imgWidth+20, $imgHeight+35);
$colorWhite=imagecolorallocate($image, 255, 255, 255);
$colorGrey=imagecolorallocate($image, 230, 230, 230);
$colorBlue=imagecolorallocate($image, 0, 0, 255);
$colorRed=imagecolorallocate($image, 255, 0, 0);
$colorBlack=imagecolorallocate($image, 0, 0, 0);
// Create border around image
//imageline($image, 20, 0, 20, $imgHeight, $colorGrey);
imageline($image, 26, 0, $imgWidth, 0, $colorGrey);
imageline($image, $imgWidth-1, 0, $imgWidth-1, $imgHeight-1, $colorGrey);
imageline($image, 26, $imgHeight-1, $imgWidth-1, $imgHeight-1, $colorGrey);

// Create grid
$hour = 0;
for ($i=1; $i<($imgWidth/$gridW); $i++){
   imageline($image, $i*$gridW, 0, $i*$gridW, $imgHeight, $colorGrey);
   imagestring($image, 1, $i*$gridW-7, $imgHeight+2, $hour.":00", $colorBlack);
   $hour++;
}


for ($i=1; $i<($imgHeight/$grid); $i++){
   imageline($image, 26, $i*$grid, $imgWidth, $i*$grid, $colorGrey);
   $yVal = round(($max-$min)-(($max-$min)/($imgHeight/$grid))*$i);
   imagestring($image, 1, 7+((3-strlen($yVal))*5), $i*$grid-4, $yVal, $colorBlack);
}

//Create the lines connecting points
for ($i=0; $i<count($graphValues2)-1; $i++)
   {imageline($image, ($i+1)*$gridW, ($imgHeight-$graphValues2[$i]), ($i+2)*$gridW, ($imgHeight-$graphValues2[$i+1]), $colorRed);}
   
for ($i=0; $i<count($graphValues1)-1; $i++)
   {imageline($image, ($i+1)*$gridW, ($imgHeight-$graphValues1[$i]), ($i+2)*$gridW, ($imgHeight-$graphValues1[$i+1]), $colorBlue); }


   
//legend
   imageline($image, 25, $imgHeight+21, 40, $imgHeight+21, $colorBlue);
   imagestring($image, 2, 45, $imgHeight+15, "Today", $colorBlack);
   imageline($image, 115, $imgHeight+21, 130, $imgHeight+21, $colorRed);
   imagestring($image, 2, 135, $imgHeight+15, "Yesterday", $colorBlack);
// Output graph and clear image from memory
imagepng($image, $usageGraph);
imagepng($image);
imagedestroy($image);
?>